import { loadConfig } from '@/config'
import { createDeployJob } from '@/deploys'
import { enqueueJob } from '@/jobs'
import { sleep } from '@/lib/utils'
import type { APIRoute } from 'astro'

export const POST: APIRoute = async ({ params: { name } }) => {
    const { deploys } = await loadConfig()
    const deploy = deploys.find(d => d.name === name)

    if (!deploy) {
        return new Response('Deploy not found', { status: 404 })
    }

    const [jobBase, deployFn] = createDeployJob(deploy, { event: 'manual' })

    let onComplete
    const completed = new Promise<void>(resolve => {
        onComplete = resolve
    })

    await enqueueJob(jobBase, deployFn, onComplete)

    await completed

    return new Response('ok')
}
